#include <stc15w.h>
#include <intrins.h>
#include "main.h"
#define CCP_S0 0x10
#define CCP_S1 0x20

void main()
{
	IO_init();
	Timer0Init();
	PWM_init();
	TX1_Busy=0;
	RX1_Cnt=0;
	TX1_Cnt=0;
	UART_init();
	REN=1;
	CR=1;
	EA=1;
	ES=1;
	RX1_clear();
	
	while(1)
	{
		get_cmd();
		Sendcmd();
		switch(cmd)//0 0x60 STOP 1 0x50 FOLLOW 2 0x10 FORWARD 3 0x30 GO right 4 0x40 GO left 5 0x20 BACKWARD
		{
			case 0:		//STOP
				motor=0;
				turn=0;
				break;
			case 1:				//FOLLOW mode
				switch(user_direction)
				{
					case 0:
						motor=1;
						turn=0;
						break;
					case 1:
						motor=1;
						turn=2;
						break;
					case 2:
						motor=1;
						turn=1;
						break;
					case 3:
						motor=0;
						turn=0;
						break;
					default:
						motor=0;
						turn=0;
				}
			case 2: 	//FORWARD
				motor=1;
				turn=0;
				break;
			case 3:
				motor=1;
				turn=2;
				break;
			case 4:
				motor=1;
				turn=1;
				break;
			case 5:
				motor=2;
				turn=0;
				break;
			default:
				motor=0;
				turn=0;
		}

	
		if(cmd==1) RX1_clear();
		if(cmd==2) RX1_clear();
		if(cmd==3) RX1_clear();
		if(cmd==4) RX1_clear();
		if(cmd==5) RX1_clear();
		servo_driver();
		motor_driver();

	}
}


void RX1_clear()
{
	u8 j;
	for(j=0;j<32;j++)  //DO NOT ATTEMPT TO USE RX1_Lenth here otherwise the MCU will RESET
	{
		RX1_Buffer[j]=0x00;
	}
}

void Sendcmd()
{
	while(TX1_Busy);
	if(send_flag==1)
	{
		switch(cmd)
		{
			case 1:
				TX1_Busy=1;
				SBUF=0x01;
				send_flag=0;
				break;
			case 2:
				TX1_Busy=1;
				SBUF=0x02;
				send_flag=0;
				break;
			case 3:
				TX1_Busy=1;
				SBUF=0x03;
				send_flag=0;
				break;		
			case 4:
				TX1_Busy=1;
				SBUF=0x04;
				send_flag=0;
				break;		
			case 5:
				TX1_Busy=1;
				SBUF=0x05;
				send_flag=0;
				break;

		}
	}
}

void UART_init()		//115200bps@22.1184MHz
{
	SCON = 0x50;		//8位数据,可变波特率
	AUXR |= 0x01;		//串口1选择定时器2为波特率发生器
	AUXR |= 0x04;		//定时器时钟1T模式
	T2L = 0xD0;		//设置定时初始值
	T2H = 0xFF;		//设置定时初始值
	AUXR |= 0x10;		//定时器2开始计时
	
}

void Uart() interrupt 4 using 1
{
	if(RI)
	{
		RI=0;
		if(SBUF==0xAA)
		{
			cmd=0;
		}
		RX1_Buffer[RX1_Cnt]=SBUF;
		RX1_Cnt++;
		if(RX1_Cnt>=32)
		{
			RX1_Cnt=0;
		}
	}
	if(TI)
	{
		TI=0;
		TX1_Busy=0;
	}
}

void Timer0Init()		//78微秒@22.1184MHz  50Hz
{
	AUXR |= 0x80;		//定时器时钟1T模式
	TMOD &= 0xF0;		//设置定时器模式
	TL0 = 0x43;		//设置定时初始值
	TH0 = 0xF9;		//设置定时初始值
	TF0 = 0;		//清除TF0标志
	TR0 = 1;		//定时器0开始计时
}

void PWM_init()
{
	ACC=P_SW1;
	ACC&=~(CCP_S0|CCP_S1); //CCP_S0=0 CCP_S1=0
	P_SW1=ACC;
	
	CCON=0x00;
	CMOD=0x04;    //PCA Clock=timer0溢出频率
	CL=0;
	CH=0;
	
	CCAPM0=0x42;
	CCAPM1=0x42;
	CCAPM2=0x42;	//使能比较器和PWM模式
	
	PCA_PWM0=0;
	PCA_PWM1=0;
	PCA_PWM2=0; 	//使能8位PWM模式并初始化
	
	CCAP0H=255;	//设置初始PWM占空比 temp_value=256*（1-duty）
	CCAP0L=255;	//CCAP0H=temp_value=CCAP0L
								//FI=0
	CCAP1H=255;	//BI=0
	CCAP1L=255;
	
	CCAP2H=237;	//Servo=1500
	CCAP2L=237;
}

void IO_init()
{
	P0M0=0;
	P0M1=0;
	P1M0=0;
	P1M1=0;
	P2M0=0;
	P2M1=0;
	P3M0=0;
	P3M1=0;
	P4M0=0;
	P4M1=0;
	P5M0=0;
	P5M1=0;
	P6M0=0;
	P6M1=0;
	P7M0=0;
	P7M1=0;
}

/*void fill_count(u8 bufferid)
{

	switch(RX1_Buffer[bufferid])		//the number is somehow halved inside the mcu,but i dont fucking know why
														//words cannot express my damning confusion
														//be careful if this number is larger than 31 this bloody thing simply refuses to work
	{//0 0x60 STOP 1 0x50 FOLLOW 2 0x10 FORWARD 3 0x30 GO LEFT 4 0x40 GO RIGHT 5 0x20 BACKWARD
		case 0x60:
			stop_count++;
			break;
		case 0x50:
			follow_count++;
			break;
		case 0x10:
			forward_count++;
			break;
		case 0x30:
			left_count++;
			break;
		case 0x40:
			right_count++;
			break;
		case 0x20:
			back_count++;
			break;
	}
}*/

void get_cmd()
{
	
	/*u8 n;
	for(n=0;n<32;n++)
	{
		fill_count(n);
	}

	if(follow_count>15) cmd=1;
	if(left_count>15) cmd=3;
	if(right_count>15) cmd=4;
	if(back_count>15) cmd=5;
	if(stop_count>15)
	{
		RX1_clear();
		cmd=0;
	}
	if(forward_count>15) cmd=2;
	follow_count=0;
	left_count=0;
	right_count=0;
	back_count=0;
	stop_count=0;
	forward_count=0;
	*/
	//0 0x60 STOP 1 0x50 FOLLOW 2 0x10 FORWARD 3 0x30 GO LEFT 4 0x40 GO RIGHT 5 0x20 BACKWARD
	u8 i;
	u8 follow_count;
	u8 left_count;
	u8 right_count;
	u8 back_count;
	u8 stop_count;
	u8 forward_count;
	for(i=0;i<=31;i++)
	{
		switch(RX1_Buffer[i])
		{
			case 0x10:
				forward_count++;
				send_flag=1;
				break;
			case 0x20:
				back_count++;
				send_flag=1;
				break;
			case 0x30:
				left_count++;
				send_flag=1;
				break;
			case 0x40:
				right_count++;
				send_flag=1;
				break;
			case 0x50:
				follow_count++;
				send_flag=1;
				break;
			case 0x60:
				stop_count++;
				send_flag=1;
				break;
		}
	}
	if(follow_count>1) cmd=1;
	if(left_count>1) cmd=3;
	if(right_count>1) cmd=4;
	if(back_count>1) cmd=5;
	if(forward_count>1) cmd=2;
	if(stop_count>1) cmd=0;
	follow_count=0;
	left_count=0;
	right_count=0;
	back_count=0;
	stop_count=0;
	forward_count=0;	
}

void servo_driver()
{
	switch(turn)
	{
		case 0:				//STRAIGHT
			CCAP2H=237;	//Servo=1500
			CCAP2L=237;
			break;
		case 1:				//RIGHT(WAS ONCE LEFT)
			CCAP2H=234;	//Servo=1250
			CCAP2L=234;	//DO NOT CHANGE THE ORDER OF CASE1 AND CASE2 OR IT WILL NOT TURN RIGHT
			break;			// i STILL DO NOT know what the FUCK IS GOING ON WITH KEIL
		case 2:				//LEFT(WAS ONCE RIGHT)
			CCAP2H=240;	//Servo=1750
			CCAP2L=240;
			break;
		default:
			CCAP2H=237;	//Servo=1500
			CCAP2L=237;
	}
}

void motor_driver()
{
	switch(motor)//0 stop 1 forward 2 backward
	{
		case 0:
			CCAP1H=0x00;
			CCAP1L=0x00;
			CCAP0H=0x00;
			CCAP0L=0x00;
			break;
		case 1:
			CCAP1H=0x90;
			CCAP1L=0x90;
			CCAP0H=0xFF;
			CCAP0L=0xFF;
			break;
		case 2:
			CCAP1H=0xFF;
			CCAP1L=0xFF;
			CCAP0H=0xA0;
			CCAP0L=0xA0;
			break;
		default:
			CCAP1H=0x00;
			CCAP1L=0x00;
			CCAP0H=0x00;
			CCAP0L=0x00;
			break;
	}
}


